from typing import Optional
from pydantic import BaseModel, Field

from .landmarktype import LandmarkType

from uuid import uuid4

# Output to frontend
class Landmark(BaseModel) :
    
    # Properties of the landmark
    name : str
    type: LandmarkType      # De facto mapping depending on how the query was executed with overpass. Should still EXACTLY correspond to the preferences
    location : tuple
    osm_type : str
    osm_id : int
    attractiveness : int
    n_tags : int
    image_url : Optional[str] = None                            # TODO future
    description : Optional[str] = None                          # TODO future
    duration : Optional[int] = 0                                # TODO future

    # Unique ID of a given landmark
    uuid: str = Field(default_factory=uuid4)                    # TODO implement this ASAP
    
    # Additional properties depending on specific tour
    must_do : bool
    is_secondary : Optional[bool] = False                       # TODO future   
    
    time_to_reach_next : Optional[int] = 0                      # TODO fix this in existing code
    next_uuid : Optional[str] = None                            # TODO implement this ASAP
